Hooks:PostHook( WeaponFactoryTweakData, "init", "GlugerLoccConversionKits_WeaponFactoryTweakData", function(self)
	--[[
		   _____ _     _    _  _____ ______ _____  
		  / ____| |   | |  | |/ ____|  ____|  __ \ 
		 | |  __| |   | |  | | |  __| |__  | |__) |
		 | | |_ | |   | |  | | | |_ |  __| |  _  / 
		 | |__| | |___| |__| | |__| | |____| | \ \ 
		  \_____|______\____/ \_____|______|_|  \_\

	]]

	local attachments_to_fiddle_with = {
		"wpn_upg_b_gluger",
		"wpn_upg_b_gluger_short",
		"wpn_upg_b_gluger_reinforced"
	}

	for part_id, part_data in pairs(self.parts) do
		if part_data.type then
			if part_data.type == "barrel_ext" then
				for index, forbid_part in pairs(attachments_to_fiddle_with) do
					local forbid_part_data = self.parts[forbid_part]
					forbid_part_data.forbids = forbid_part_data.forbids or {}

					table.insert(forbid_part_data.forbids, part_id)
				end
			elseif part_data.type == "barrel" then
				for index, forbid_part in pairs(attachments_to_fiddle_with) do
					local forbid_part_data = self.parts[forbid_part]
					forbid_part_data.forbids = forbid_part_data.forbids or {}

					table.insert(forbid_part_data.forbids, part_id)
				end
			elseif part_data.type == "sight" then
				for index, override_part in pairs(attachments_to_fiddle_with) do
					local override_part_data = self.parts[override_part]
					override_part_data.override = override_part_data.override or {}

					override_part_data.override[part_id] = override_part_data.override[part_id] or {}
					override_part_data.override[part_id].parent = false
					override_part_data.override[part_id].a_obj = "a_rds_gluger"
				end
			end
		end
	end

	-- Welcome to barrel gross town.
	self.parts.wpn_fps_pis_g18c_body_frame.visibility = self.parts.wpn_fps_pis_g18c_body_frame.visibility or {}
	table.insert(self.parts.wpn_fps_pis_g18c_body_frame.visibility, {
		condition = function(self, part, npc, blueprint)
			if blueprint and table.contains_any(blueprint, attachments_to_fiddle_with) then
				return true
			end
		end,
		objects = {
			g_glock_frame_lod0 = true,
			g_barrel_18c = false
		}
	})

	self.parts.wpn_fps_pis_g17_body_standard.visibility = self.parts.wpn_fps_pis_g17_body_standard.visibility or {}
	table.insert(self.parts.wpn_fps_pis_g17_body_standard.visibility, {
		condition = function(self, part, npc, blueprint)
			if blueprint and table.contains_any(blueprint, attachments_to_fiddle_with) then
				return true
			end
		end,
		objects = {
			g_body = true,
			g_barrel = false
		}
	})

	--[[
		  _      ____   _____ _____ 
		 | |    / __ \ / ____/ ____|
		 | |   | |  | | |   | |     
		 | |   | |  | | |   | |     
		 | |___| |__| | |___| |____ 
		 |______\____/ \_____\_____|

	]]

	-- Steal Barrel Extensions
	self.wpn_fps_pis_breech.override = self.wpn_fps_pis_breech.override or {}
	self.wpn_fps_pis_x_breech.override = self.wpn_fps_pis_x_breech.override or {}
	local parts_to_scan = self.wpn_fps_pis_g18c.uses_parts

	if parts_to_scan then
		for index, part_id in pairs(parts_to_scan) do
			if self.parts[part_id] and self.parts[part_id].type and self.parts[part_id].type == "barrel_ext" then
				table.insert(self.wpn_fps_pis_breech.uses_parts, part_id)
				table.insert(self.wpn_fps_pis_x_breech.uses_parts, part_id)
				
				self.wpn_fps_pis_x_breech.override[part_id] = {
					depends_on = "slide"
				}
				self.wpn_fps_pis_x_breech.override[part_id] = {
					depends_on = "slide"
				}
			end
		end
	end

	local attachments_to_fiddle_with = {
		"wpn_upg_locc_g17_b_standard",
		"wpn_upg_locc_g22c_b_standard",
		"wpn_upg_locc_g22c_b_long",
		"wpn_upg_locc_g26_b_custom",
		"wpn_upg_locc_g26_b_standard",
		"wpn_upg_locc_g18c_b_standard"
	}

	for part_id, part_data in pairs(self.parts) do
		if part_data.type then
			if part_data.type == "barrel" then
				for index, forbid_part in pairs(attachments_to_fiddle_with) do
					local forbid_part_data = self.parts[forbid_part]
					forbid_part_data.forbids = forbid_part_data.forbids or {}

					table.insert(forbid_part_data.forbids, part_id)
				end
			elseif part_data.type == "sight" then
				for index, override_part in pairs(attachments_to_fiddle_with) do
					local override_part_data = self.parts[override_part]
					override_part_data.override = override_part_data.override or {}

					override_part_data.override[part_id] = override_part_data.override[part_id] or {}
					override_part_data.override[part_id].parent = "slide"
				end
			end
		end
	end
end)